#!/usr/bin/perl
#  ElimineColonnesLignesDeMatrice.pl

<<DOC; 
B. Habert
13/10/00

               ElimineColonnesLignesDeMatrice.pl :


Format d'entre : 
ElimineColonnesLignesDeMatrice.pl <matrice produite par StatWordByFile2Matrice.pl><profil de colonnes et statut><profil de lignes et statut>
Exemple d'appel :
    ElimineColonnesLignesDeMatrice.pl es7.Matrice es7.ProfilColonnes.Emondage es7.ProfilLignes.Emondage 
    ElimineColonnesLignesDeMatrice.pl es7.Matrice es7.ProfilColonnes es7.ProfilLignes.Emondage 
(dans ce deuxime cas, les profils colonnes, les traits donc, sont laisss  l'identique).

Dans les profils, la dernire colonne est soit O soit N. Si elle n'est pas O, le trait (ou l'individu) sera limin de la matrice rsultant. 
Si l'on veut garder soit les traits soit les individus inchangs, il suffit de fournir tel quel le fichier correspondant produit par StatWordByFile2Matrice.pl

Format de sortie :
	Une matrice dans lequel un ou des traits et/ou un ou des individus ont t limins. Le nom est celui de la matrice de dpart avec le suffixe $SuffixeMatriceEmondee [.Emondee]							       

A faire :

Bugs et problmes :

DOC

if (@ARGV != 3 ) {die "Usage : ElimineColonnesLignesDeMatrice.pl <matrice produite par StatWordByFile2Matrice.pl><profil de colonnes et statut><profil de lignes et statut>\n" ; }


#$DateCourante                                 = `date` ;
$DateCourante                                  = localtime ;
$NomFichierJournalMatrice                      = "Matrices.Journal" ;
$NomFichierMatrice                             = $ARGV[0] ;
$SuffixeMatriceEmondee                         = ".Emondee" ;
$NomFichierMatriceEmondee                      = $ARGV[0] . $SuffixeMatriceEmondee ;
$NomFichierProfilColonnesMatrice               = $ARGV[1] ;
$NomFichierProfilLignesMatrice                 = $ARGV[2] ;
%NumeroTrait2AGarderOuNon                      = () ;
%Individu2AGarderOuNon                         = () ;
$AGarder                                       = "O" ;
$NomColonneIndividu                            = "ID" ;

open(PROFILLIGNES, "<$NomFichierProfilLignesMatrice") ;
while ($LigneProfilLigne = <PROFILLIGNES>){
  if ($LigneProfilLigne =~ /\t([^\t]+)\t([ON])\r?$/) 
  {$NomIndividu  = $1 ;
   $AGarderOuNon = $2 ;
   # print "$NumeroTrait\t$AGarderOuNon\n" ;
   $Individu2AGarderOuNon{$NomIndividu} = $AGarderOuNon ;
  }
}
close(PROFILLIGNES) ;

open(PROFILCOLONNES, "<$NomFichierProfilColonnesMatrice") ;
while ($LigneProfilColonne = <PROFILCOLONNES>){
  if ($LigneProfilColonne =~ /\t(\d+)\t([ON])\r?$/) 
  {$NumeroTrait  = $1 ;
   $AGarderOuNon = $2 ;
   # print "$NumeroTrait\t$AGarderOuNon\n" ;
   $NumeroTrait2AGarderOuNon{$NumeroTrait} = $AGarderOuNon ;
  }
}
close(PROFILLIGNES) ;

open(MATRICE, "<$NomFichierMatrice") ;
open(MATRICEEMONDEE, ">$NomFichierMatriceEmondee") ;
while ($LigneMatrice = <MATRICE>){
     chop($LigneMatrice) ;
     $LigneMatrice =~ /^([^\t]+)/ ;
     $NomIndividuCourant = $1 ;
     if ($Individu2AGarderOuNon{$NomIndividuCourant} eq $AGarder ||
         $NomIndividuCourant eq $NomColonneIndividu)
     {
       @ListeMatrice = split(/\t/, $LigneMatrice) ;
       print MATRICEEMONDEE "$ListeMatrice[0]" ;
       for ($i = 1 ; $i <= $#ListeMatrice ; $i++)
       {if ($NumeroTrait2AGarderOuNon{$i} eq $AGarder)
         {print MATRICEEMONDEE "\t$ListeMatrice[$i]" ;
         }
       }
       print MATRICEEMONDEE "\n" ;
     }
}
close(MATRICE) ;
close(MATRICEEMONDEE) ;

    print  "ElimineColonnesLignesDeMatrice.pl $NomFichierMatrice $NomFichierProfilColonnesMatrice $NomFichierProfilLignesMatrice \n\n" ;
    print  "Fichier de sortie : $NomFichierMatriceEmondee \n\n" ;

MetAJourJournalMatrice() ;

####################### Routines #########################

sub MetAJourJournalMatrice{
    open(JOURNAL, ">>$NomFichierJournalMatrice") ;
    print JOURNAL "\n\n---------------\n$DateCourante\n\n" ;
    print JOURNAL "ElimineColonnesLignesDeMatrice.pl $NomFichierMatrice $NomFichierProfilColonnesMatrice $NomFichierProfilLignesMatrice \n\n" ;
    print JOURNAL "Fichier de sortie : $NomFichierMatriceEmondee \n\n" ;
    close(JOURNAL) ;
}

